clc
clear
close all
%---------------------------------
Rc=39.6;
C1=0.001;
C2=0.001;
R=25;
VD=0.82;
L=.00121;
q=1.6* 10^(-19);
k0=1.3805*10^(-23);
Ego=1.1;
A=1.8;
iscr=8.21;
kl=4.79*10^(-3);
T=38+273;
landa=950;
Tr=298;

Np=1;
Ns=54;

ior=iscr/( (exp(q*32.9/(Ns*k0*A*T)))-1);
iph=(iscr+kl*(T-Tr))*landa/1000;
irs=(ior*(T/Tr)^3)*exp(q*Ego*(T-Tr)/(k0*A*T*Tr));
 Vref=k0*A*T*Ns*log((0.091*iph+irs)/irs)/q;
%-------------------------------
dt=.0001;
% t_1=0:dt:1;
t_1=0:dt:0.5;
n=numel(t_1);
ipv=zeros(1,n);   uu=zeros(1,n);   x1=zeros(1,n);   x2=zeros(1,n);       x3=zeros(1,n); 
xx1=zeros(1,n);   xx2=zeros(1,n);       xx3=zeros(1,n); 
f1=zeros(1,n);    g1=zeros(1,n);   f2=zeros(1,n);   g2=zeros(1,n);       s=zeros(1,n);  ss=zeros(1,n);
e1=zeros(1,n);    e2=zeros(1,n);   x2d=zeros(1,n);  xdot2d=zeros(1,n);   u=zeros(1,n);  phihat=zeros(1,n);
x1(1)=0;    x2(1)=0;   x3(1)=0; 
xx1(1)=0;    xx2(1)=0;   xx3(1)=0; 

alfa=.7;     kk=600;     gammma=.001;
r=19/17;
%--------------------------------
d1=60+40*sin(.6*pi*t_1);
for i=1:n-1
 
    f1(i)=(x1(i) -Rc*x2(i)/(1+Rc/R) +( (Rc/(R+Rc))-1)*x3(i) - VD)/L;
    g1(i)=(Rc*x2(i)/(1+Rc/R) -( (Rc/(R+Rc))-1)*x3(i) + VD)/L;
    f2(i)=(x2(i)/(1+Rc/R) -x3(i)/(R+Rc) )/C2;
    g2(i)=(-x2(i)/(1+Rc/R))/C2;
    
    ipv(i)=Np*iph-Np*irs*(exp((q*x1(i))/(Ns*A*k0*T))  -1);
    e1(i)=x1(i)-Vref;
    x2d(i)= ipv(i);
    e2(i)=x2(i)-x2d(i);
    ss(i)=e2(i)^r-alfa*e1(i);
    xdot2d(i)=-Np*irs*q/(Ns*A*k0*T)*exp((q*x1(i))/(Ns*A*k0*T))*((ipv(i)-x2(i))/C1);
    
    u(i)=(-alfa*e2(i)^(2-r)/(r*C1)-f1(i)+xdot2d(i)-(kk)*sign(ss(i)) )/g1(i);

%     
%     phihat(i+1)=gammma*abs(s(i))*dt+phihat(i);
%     
    x1(i+1)=((ipv(i)-x2(i))/C1)*dt+x1(i);
    
    
    x2(i+1)=(f1(i)+g1(i)*u(i)+d1(i))*dt+x2(i);
    
    
    x3(i+1)=(f2(i)+g2(i)*u(i))*dt+x3(i);
    
end
i=n;
u(i)=(-alfa*e2(i)/C1-f1(i)+xdot2d(i)-kk*sign(100*s(i)))/g1(i);
ipv(i)=Np*iph-Np*irs*(exp((q*x1(i))/(Ns*A*k0*T))  -1);

%% plotion

figure(1)
subplot(211)
plot(t_1,x1,'linewidth',2)
grid on
xlabel('t(sec)')
ylabel('V_p_v')
V_SMC_1 = x1;

subplot(212)
P_SMC_1 = x1.*ipv;
plot(t_1,P_SMC_1,'linewidth',2)
grid on
xlabel('t(sec)')
ylabel('Power')

figure(2)
subplot(211)
plot(t_1,u,'linewidth',2)
grid on
xlabel('t(sec)')
ylabel('input')
U_SMC_1 = u;

subplot(212)
plot(t_1,s,'linewidth',2)
grid on
xlabel('t(sec)')
ylabel('sliding surface')
S_SMC_1 = s;

figure(3)
% subplot(211)
plot(t_1,ipv,'linewidth',2)
grid on
xlabel('t(sec)')
ylabel('ipv')
I_SMC_1 = ipv;

save('yeganeh_TSMC_ok','t_1','V_SMC_1','P_SMC_1','U_SMC_1','S_SMC_1','I_SMC_1');