clc
clear
close all
%---------------------------------
Rc=39.6;
C1=0.001;
C2=0.001;
R=25;
VD=0.82;
L=.00121;
q=1.6* 10^(-19);
k0=1.3805*10^(-23);
Ego=1.1;
A=1.8;
iscr=8.21;
kl=4.79*10^(-3);
T=38+273;
landa=950;
Tr=298;
w=100;
lambda=sqrt(0.1);

Np=1;
Ns=54;

ior=iscr/( (exp(q*32.9/(Ns*k0*A*T)))-1);
iph=(iscr+kl*(T-Tr))*landa/1000;
irs=(ior*(T/Tr)^3)*exp(q*Ego*(T-Tr)/(k0*A*T*Tr));
Vref=k0*A*T*Ns*log((0.091*iph+irs)/irs)/q;
%-------------------------------
dt=.0001;
% t_2=0:dt:1;
t_2=0:dt:0.5;
n=numel(t_2);
ipv=zeros(1,n);   uu=zeros(1,n);   x1=zeros(1,n);   x2=zeros(1,n);       x3=zeros(1,n); 
f1=zeros(1,n);    g1=zeros(1,n);   f2=zeros(1,n);   g2=zeros(1,n);       s=zeros(1,n);
e1=zeros(1,n);    e2=zeros(1,n);   x2d=zeros(1,n);  xdot2d=zeros(1,n);   u=zeros(1,n);  phihat=zeros(1,n);
x1(1)=0;    x2(1)=0;   x3(1)=0;     u1=zeros(1,n);    u=zeros(1,n);   d1=zeros(1,n); 
alfa=.7;     kk=10;     gammma=.001;
%--------------------------------
% d1=10*sin(100*t);
for i=1:n-1
 
    f1(i)=(x1(i) -Rc*x2(i)/(1+Rc/R) +( (Rc/(R+Rc))-1)*x3(i) - VD)/L;
    g1(i)=(Rc*x2(i)/(1+Rc/R) -( (Rc/(R+Rc))-1)*x3(i) + VD)/L;
    f2(i)=(x2(i)/(1+Rc/R) -x3(i)/(R+Rc) )/C2;
    g2(i)=(-x2(i)/(1+Rc/R))/C2;
    
    ipv(i)=Np*iph-Np*irs*(exp((q*x1(i))/(Ns*A*k0*T))  -1);
    e1(i)=x1(i)-Vref;
    x2d(i)= ipv(i);
    e2(i)=x2(i)-x2d(i);
    s(i)=e2(i)-alfa*e1(i);
    xdot2d(i)=-Np*irs*q/(Ns*A*k0*T)*exp((q*x1(i))/(Ns*A*k0*T))*((ipv(i)-x2(i))/C1);
    u1(i+1)=(-w*tanh(s(i)))*dt+u1(i);
    u(i)=-lambda*sqrt(abs(s(i)))*tanh(s(i))+u1(i);
    
    x1(i+1)=((ipv(i)-x2(i))/C1)*dt+x1(i);
    
    
    x2(i+1)=(f1(i)+g1(i)*u(i)+d1(i))*dt+x2(i);
    
    
    x3(i+1)=(f2(i)+g2(i)*u(i))*dt+x3(i);
    
end
i=n;
u(i)=(-alfa*e2(i)/C1-f1(i)+xdot2d(i)-kk*sign(100*s(i)))/g1(i);
ipv(i)=Np*iph-Np*irs*(exp((q*x1(i))/(Ns*A*k0*T))  -1);
%% plotion

figure(1)
subplot(211)
plot(t_2,x1,'linewidth',2)
grid on
xlabel('t(sec)')
ylabel('V_p_v')
V_SMC_2 = x1;

subplot(212)
P_SMC_2 = x1.*ipv;
plot(t_2,P_SMC_2,'linewidth',2)
grid on
xlabel('t(sec)')
ylabel('Power')

figure(2)
subplot(211)
plot(t_2,u,'linewidth',2)
grid on
xlabel('t(sec)')
ylabel('input')
U_SMC_2 = u;

subplot(212)
plot(t_2,s,'linewidth',2)
grid on
xlabel('t(sec)')
ylabel('sliding surface')
S_SMC_2 = s;

figure(3)
% subplot(211)
plot(t_2,ipv,'linewidth',2)
grid on
xlabel('t(sec)')
ylabel('ipv')
I_SMC_2 = ipv;

save('yeganeh_supertwist_ok','t_2','V_SMC_2','P_SMC_2','U_SMC_2','S_SMC_2','I_SMC_2');

